/**
   Javascript File for XULRPN User Interface to logics
 */


var CalcUi = {
    
    get NewValue() {return document.getElementById("newvalue");},
    get StackValue() {return document.getElementById("stack0");},
    get Stack1Value() {return document.getElementById("stack1");},

    calc: null,
    isInputed: false,
    hasDot: false,
    hasAfterDot: false,
    isAfterCalc: false,
    func: null,

    init: function() {
	this.calc = new Calculator();
	this.calc.init();
	this.isInputed = false;
	this.NewValue.value = 0;
	this._showLast();
	this._clearInput();
    },
    _clearInput: function() {
	hasDot: false;
	hasAfterDot: false;
    },
    clear: function() {
	this.NewValue.value = 0;
	this._clearInput();
    },
    backspace: function() {
    },
    enter: function() {
	var val = this.NewValue.value;
	this.calc.push(val);
	this.NewValue.value = 0;
	this._showLast();
    },
    push: function(val) {
	if (this.isAfterCalc) {
	    this.calc.push(this.NewValue.value);
	    this.NewValue.value = 0;
	    this._showLast();
	}
	if (this.hasDot && !this.hasAfterDot) {
	    this.NewValue.value = this.NewValue.value + '.' + val;
	    this.hasAfterDot = true;
	} else if (this.NewValue.value == '0') {
	    this.NewValue.value = val;
	} else {
	    this.NewValue.value = this.NewValue.value + val;
	}
	this.isAfterCalc = false;
    },
    dot: function() {
	if (!this.hasDot) {
	    this.hasDot = true;
	    this.hasAfterDot = false;
	}
    },
    irekae: function() {
	if (this.NewValue.value != '0') {
	    this.NewValue.value = this.NewValue.value * -1;
	}
    },
    _dofunc: function(dofunc) {
	if (!this.isAfterCalc && this.NewValue.value != '0') {
	    this.calc.push(this.NewValue.value);
	    this.NewValue.value = 0;
	} else if (this.StackValue.value != '') {
	    this.calc.push(this.NewValue.value);
	    this.NewValue.value = 0; 
	}
	if (this.calc.isCalc()) {
	    this.func = new Function(dofunc);
	    this.func();
	    this._afterCalc();
	}
	this._showLast();
    },
    plus:function() {
	this._dofunc("this.calc.plus()");
    },
    minus: function() {
	this._dofunc("this.calc.minus()");
    },
    sub: function() {
	this._dofunc("this.calc.sub()");
    },
    div: function() {
	this._dofunc("this.calc.div()");
    },
    _afterCalc: function() {
	var value = this.calc.pop();
	this.NewValue.value = value;
	this._showLast();
	this.isAfterCalc = true;
	this._clearInput();
    },
    _showLast: function() {
	this.StackValue.value = this.calc.getStack(0);
	this.Stack1Value.value = this.calc.getStack(1);
    }

};

